using C1.Win.FlexGrid;

namespace FlexGrid6_MeasureCellTest
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            c1FlexGrid1.AllowMerging = AllowMergingEnum.Custom;
            c1FlexGrid1.AllowResizing = AllowResizingEnum.Both;

            //Build a long string:
            string todisplay = "";
            const int MAX = 100;
            for (int index = 0; index < MAX; index++)
            {
                if (index > 0)
                    todisplay += " // ";
                todisplay += "part_" + index + "_of_" + MAX;
            }

            CellStyle styleWrap = this.c1FlexGrid1.Styles.Add("Wrap", this.c1FlexGrid1.Styles.Normal);
            styleWrap.WordWrap = true;

            //merged range
            var range = this.c1FlexGrid1.GetCellRange(1, 1, 3, 5);
            this.c1FlexGrid1.MergedRanges.Add(range);
            range.Style = styleWrap;
            range.Data = todisplay;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            c1FlexGrid1.Rows[3].Height = GetCalculatedHeight(c1FlexGrid1.MergedRanges[0]);
        }

        int GetCalculatedHeight(CellRange cellRange)
        {
            var totalHeight = 0;
            for(int r = cellRange.TopRow; r <= cellRange.BottomRow; r++)
            {
                totalHeight += c1FlexGrid1.MeasureCellSize(r, 1).Height;
            }
            return totalHeight - (cellRange.BottomRow - cellRange.TopRow) * (c1FlexGrid1.Rows[0].HeightDisplay - 1);
        }

        private void button2_Click(object sender, EventArgs e)
        {
            for (int row = 0; row < this.c1FlexGrid1.Rows.Count; row++)
            {
                this.c1FlexGrid1.Rows[row].Height = -1;
            }
        }
    }
}
